-- Ben Lin 6/98
-- Only need one global observer for this version
class FILLER inherit OBSERVER
creation make
feature
	make is
	do
	end

	update(command : ADD_QUEEN) is
	local
		bb : QUEENBOARD
		x, y : INTEGER
		count : INTEGER
		row, col : INTEGER
	do
		row := command.x
		col := command.y
		bb := command.bb
		count := 0
		from x := 1
		until x > bb.size
		loop
			inspect(bb.board.item(x, col))
			when 0 then
				command.forced_mark(x, col)
			when 1 then
				count := count + 1
			else
			end
			x := x + 1
		end

		if count > 1 then
			command.forced_die
		end

		from
			count := 0
			if (row < col) then
				x := 1
				y := col - row + 1
			else
				x := row - col + 1
				y := 1
			end
		until x > bb.size or y > bb.size
		loop
			inspect bb.board.item(x, y)
			when 0 then
				command.forced_mark(x, y)
			when 1 then
				count := count + 1
			else
			end
			x := x + 1
			y := y + 1
		end

		if count > 1 then
			command.forced_die
		end

		from
			count := 0

			if (row < bb.size - col + 1) then
				x := 1
				y := col + row - 1
			else
				x := row - bb.size + col
				y := bb.size
			end
		until x > bb.size or y < 1
		loop
			inspect bb.board.item(x, y)
			when 0 then
				command.forced_mark(x, y)
			when 1 then
				count := count + 1
			else
			end
			x := x + 1
			y := y - 1
		end

		if count > 1 then
			command.forced_die
		end
	end
end
