class ROW_FILLER inherit OBSERVER
creation make
feature
	make(row_number : INTEGER) is
	do
		row := row_number
	end

	update(command : ADD_QUEEN) is
	local
		bb : QUEENBOARD
		i : INTEGER
		count : INTEGER
	do
		bb := command.bb
		count := 0
		from i := 1
		until i > bb.size
		loop
			inspect(bb.board.item(row, i))
			when 0 then
				command.forced_mark(row, i)
			when 1 then
				count := count + 1
			else
			end
			i := i + 1
		end

		if count > 1 then
			command.forced_die
		end
	end

feature {NONE}
	row : INTEGER
end
